# Storage & Backup › Backup & Disaster recovery solutions › Managed Veeam for Public VCF aaS API

> Part of the OVHcloud developer hub. Index of every page and section: https://developers.eu.ovhcloud.com/llms.txt
> The Storage & Backup product's sections: https://developers.eu.ovhcloud.com/reference/storage-backup/llms.txt
> Everything in one file: https://developers.eu.ovhcloud.com/llms-full.txt

> 5 operations of the OVHcloud API. Calls carry `authorization: Bearer $OVH_TOKEN`; the EU host is shown, Canada and the United States answer on api.ca.ovhcloud.com and api.us.ovhcloud.com.

Page: https://developers.eu.ovhcloud.com/reference/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas/

OpenAPI v1: https://api.eu.ovhcloud.com/1.0/__schemas/developer-hub-navigation/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas.json?format=openapi3
OpenAPI v2: https://api.eu.ovhcloud.com/v2/__schemas/developer-hub-navigation/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas.json?format=openapi3

## Operations

- `GET /vmwareCloudDirector/backup/{backupId}/task` — List backup tasks
- `GET /vmwareCloudDirector/backup` — List backup services
- `GET /vmwareCloudDirector/backup/{backupId}` — Get a backup service
- `GET /vmwareCloudDirector/backup/{backupId}/task/{taskId}` — Get a backup task
- `PUT /vmwareCloudDirector/backup/{backupId}` — Update a backup service

## List backup tasks

`GET /v2/vmwareCloudDirector/backup/{backupId}/task`

Link: https://developers.eu.ovhcloud.com/reference/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas/#get-vmwareclouddirector-backup-backupid-task

**Status:** Stable production version  
**IAM actions:** `vmwareCloudDirectorBackup:apiovh:task/get`

Returns the asynchronous tasks of the backup service.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `X-Pagination-Cursor` | header | string |  | Pagination cursor |
| `X-Pagination-Size` | header | integer |  | Pagination size |
| `backupId` | path | string | yes | Backup ID |

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | common.Task[] | successful operation |

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `createdAt` | string (date-time) | read-only | Creation date of the task |
| `errors` | common.TaskError[] | read-only | Errors that occurred on the task |
| `errors[].message` | string | read-only | Error description |
| `finishedAt` | string (date-time) | read-only | Ending date of the task |
| `id` | string (uuid) | read-only | Unique identifier of the task |
| `link` | string | read-only | Link to the related resource |
| `message` | string | read-only | Description of the task |
| `progress` | common.TaskProgress[] | read-only | Progress steps of the asynchronous operation |
| `progress[].name` | string | read-only | Progress step name |
| `progress[].status` | common.TaskStatusEnum | read-only | Current status of the progress step — one of `DONE`, `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `startedAt` | string (date-time) | read-only | Starting date of the task |
| `status` | common.TaskStatusEnum | read-only | Current global status of the task — one of `DONE`, `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `type` | string | read-only | Type of the task |
| `updatedAt` | string (date-time) | read-only | Last update of the task |

```json
[
  {
    "createdAt": "2024-01-01T12:00:00Z",
    "errors": [
      {
        "message": "string"
      }
    ],
    "finishedAt": "2024-01-01T12:00:00Z",
    "id": "00000000-0000-0000-0000-000000000000",
    "link": "string",
    "message": "string",
    "progress": [
      {
        "name": "string",
        "status": "DONE"
      }
    ],
    "startedAt": "2024-01-01T12:00:00Z",
    "status": "DONE",
    "type": "string",
    "updatedAt": "2024-01-01T12:00:00Z"
  }
]
```

### Example

```bash
curl -X GET \
  "https://api.eu.ovhcloud.com/v2/vmwareCloudDirector/backup/{backupId}/task" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN"
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

result = client.get("/v2/vmwareCloudDirector/backup/{backupId}/task")

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

$result = $ovh->get("/v2/vmwareCloudDirector/backup/{backupId}/task");

print_r($result);
?>
```

## List backup services

`GET /v2/vmwareCloudDirector/backup`

Link: https://developers.eu.ovhcloud.com/reference/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas/#get-vmwareclouddirector-backup

**Status:** Stable production version  
**IAM actions:** `vmwareCloudDirectorBackup:apiovh:get`

Returns the backup services, with their offers and status.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `X-Pagination-Cursor` | header | string |  | Pagination cursor |
| `X-Pagination-Size` | header | integer |  | Pagination size |
| `iamTags` | query | object |  | Filter resources on IAM tags |

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | vmwareCloudDirector.backup.BackupDetailsWithIAM[] | successful operation |

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `createdAt` | string (date-time) | read-only | Datetime when backup was enabled |
| `currentState` | vmwareCloudDirector.backup.CurrentState | read-only | Configuration currently in force on the platform. It catches up with targetSpec once the requested change has been applied. |
| `currentState.azName` | vmwareCloudDirector.AZNameEnum | read-only | Availability zone of VMware Cloud Director organization backup — one of `ca-east-bhs-a`, `eu-central-waw-a`, `eu-west-eri-a`, `eu-west-lim-a`, `eu-west-rbx-a`, `eu-west-sbg-a`, `us-east-vin-a`, `us-west-hil-a` |
| `currentState.offers` | vmwareCloudDirector.backup.CurrentStateOffer[] | read-only | List of your VMware Cloud Director organization backup offers |
| `currentState.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | read-only | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `currentState.offers[].protectionPrimaryRegion` | vmwareCloudDirector.RegionNameEnum | read-only | Backup repository primary region — one of `ap-south-mum`, `ap-southeast-sgp`, `ap-southeast-syd`, `ca-east-bhs`, `ca-east-tor`, `eu-central-waw`, `eu-west-eri`, `eu-west-gra`, `eu-west-lim`, `eu-west-par`, `eu-west-rbx`, `eu-west-sbg`, … |
| `currentState.offers[].protectionReplicatedRegion` | vmwareCloudDirector.RegionNameEnum | read-only | Backup repository replicated region — one of `ap-south-mum`, `ap-southeast-sgp`, `ap-southeast-syd`, `ca-east-bhs`, `ca-east-tor`, `eu-central-waw`, `eu-west-eri`, `eu-west-gra`, `eu-west-lim`, `eu-west-par`, `eu-west-rbx`, `eu-west-sbg`, … |
| `currentState.offers[].quotaInTB` | integer | read-only | Backup repository quota in TB |
| `currentState.offers[].status` | vmwareCloudDirector.BackupResourceStatusEnum | read-only | Backup offer status — one of `CREATING`, `DISABLED`, `DISABLING`, `READY`, `REMOVED`, `REMOVING`, `UPDATING` |
| `currentState.offers[].usedSpaceInGB` | number | read-only | Backup repository used space in GB |
| `currentTasks` | common.CurrentTask[] | read-only | Asynchronous operations ongoing on the VMware Cloud Director organization backup service |
| `currentTasks[].errors` | common.TaskError[] | read-only | Errors that occurred on the task |
| `currentTasks[].errors[].message` | string | read-only | Error description |
| `currentTasks[].id` | string (uuid) | read-only | Identifier of the current task |
| `currentTasks[].link` | string | read-only | Link to the task details |
| `currentTasks[].status` | common.CurrentTaskStatusEnum | read-only | Current global status of the current task — one of `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `currentTasks[].type` | string | read-only | Type of the current task |
| `iam` | iam.ResourceMetadata | read-only | IAM resource metadata |
| `iam.displayName` | string | read-only | Resource display name |
| `iam.id` | string (uuid) | read-only | Unique identifier of the resource |
| `iam.state` | iam.ResourceMetadata.StateEnum | read-only | Resource state — one of `EXPIRED`, `IN_CREATION`, `OK`, `SUSPENDED` |
| `iam.tags` | object | read-only | Resource tags. Tags that were internally computed are prefixed with ovh: |
| `iam.urn` | string | read-only | Unique resource name used in policies |
| `id` | string | read-only | Unique identifier of the VMware Cloud Director backup |
| `resourceStatus` | vmwareCloudDirector.BackupResourceStatusEnum | read-only | Reflects the readiness of the VMware Cloud Director organization backup service. A new target specification request will be accepted only in `READY` status. — one of `CREATING`, `DISABLED`, `DISABLING`, `READY`, `REMOVED`, `REMOVING`, `UPDATING` |
| `targetSpec` | vmwareCloudDirector.backup.TargetSpec | read-only | Configuration you requested. While a change is still being applied it differs from currentState. |
| `targetSpec.offers` | vmwareCloudDirector.backup.TargetOffer[] | yes | List of your VMware Cloud Director backup offers |
| `targetSpec.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | yes | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `targetSpec.offers[].quotaInTB` | integer | yes | Backup repository quota in TB |
| `updatedAt` | string (date-time) | read-only | Datetime when backup is modified |

```json
[
  {
    "createdAt": "2024-01-01T12:00:00Z",
    "currentState": {
      "azName": "ca-east-bhs-a",
      "offers": [
        {
          "name": "BRONZE",
          "protectionPrimaryRegion": "ap-south-mum",
          "protectionReplicatedRegion": "ap-south-mum",
          "quotaInTB": 0,
          "status": "CREATING",
          "usedSpaceInGB": 0
        }
      ]
    },
    "currentTasks": [
      {
        "errors": [
          {
            "message": "string"
          }
        ],
        "id": "00000000-0000-0000-0000-000000000000",
        "link": "string",
        "status": "ERROR",
        "type": "string"
      }
    ],
    "iam": {
      "displayName": "string",
      "id": "00000000-0000-0000-0000-000000000000",
      "state": "EXPIRED",
      "tags": {
        "key": "string"
      },
      "urn": "string"
    },
    "id": "string",
    "resourceStatus": "CREATING",
    "targetSpec": {
      "offers": [
        {
          "name": "BRONZE",
          "quotaInTB": 0
        }
      ]
    },
    "updatedAt": "2024-01-01T12:00:00Z"
  }
]
```

### Example

```bash
curl -X GET \
  "https://api.eu.ovhcloud.com/v2/vmwareCloudDirector/backup" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN"
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

result = client.get("/v2/vmwareCloudDirector/backup")

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

$result = $ovh->get("/v2/vmwareCloudDirector/backup");

print_r($result);
?>
```

## Get a backup service

`GET /v2/vmwareCloudDirector/backup/{backupId}`

Link: https://developers.eu.ovhcloud.com/reference/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas/#get-vmwareclouddirector-backup-backupid

**Status:** Stable production version  
**IAM actions:** `vmwareCloudDirectorBackup:apiovh:get`

Returns the backup service: offers with their quota and used space, availability zone and status.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `backupId` | path | string | yes | Backup ID |

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | vmwareCloudDirector.backup.BackupDetailsWithIAM | successful operation |

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `createdAt` | string (date-time) | read-only | Datetime when backup was enabled |
| `currentState` | vmwareCloudDirector.backup.CurrentState | read-only | Configuration currently in force on the platform. It catches up with targetSpec once the requested change has been applied. |
| `currentState.azName` | vmwareCloudDirector.AZNameEnum | read-only | Availability zone of VMware Cloud Director organization backup — one of `ca-east-bhs-a`, `eu-central-waw-a`, `eu-west-eri-a`, `eu-west-lim-a`, `eu-west-rbx-a`, `eu-west-sbg-a`, `us-east-vin-a`, `us-west-hil-a` |
| `currentState.offers` | vmwareCloudDirector.backup.CurrentStateOffer[] | read-only | List of your VMware Cloud Director organization backup offers |
| `currentState.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | read-only | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `currentState.offers[].protectionPrimaryRegion` | vmwareCloudDirector.RegionNameEnum | read-only | Backup repository primary region — one of `ap-south-mum`, `ap-southeast-sgp`, `ap-southeast-syd`, `ca-east-bhs`, `ca-east-tor`, `eu-central-waw`, `eu-west-eri`, `eu-west-gra`, `eu-west-lim`, `eu-west-par`, `eu-west-rbx`, `eu-west-sbg`, … |
| `currentState.offers[].protectionReplicatedRegion` | vmwareCloudDirector.RegionNameEnum | read-only | Backup repository replicated region — one of `ap-south-mum`, `ap-southeast-sgp`, `ap-southeast-syd`, `ca-east-bhs`, `ca-east-tor`, `eu-central-waw`, `eu-west-eri`, `eu-west-gra`, `eu-west-lim`, `eu-west-par`, `eu-west-rbx`, `eu-west-sbg`, … |
| `currentState.offers[].quotaInTB` | integer | read-only | Backup repository quota in TB |
| `currentState.offers[].status` | vmwareCloudDirector.BackupResourceStatusEnum | read-only | Backup offer status — one of `CREATING`, `DISABLED`, `DISABLING`, `READY`, `REMOVED`, `REMOVING`, `UPDATING` |
| `currentState.offers[].usedSpaceInGB` | number | read-only | Backup repository used space in GB |
| `currentTasks` | common.CurrentTask[] | read-only | Asynchronous operations ongoing on the VMware Cloud Director organization backup service |
| `currentTasks[].errors` | common.TaskError[] | read-only | Errors that occurred on the task |
| `currentTasks[].errors[].message` | string | read-only | Error description |
| `currentTasks[].id` | string (uuid) | read-only | Identifier of the current task |
| `currentTasks[].link` | string | read-only | Link to the task details |
| `currentTasks[].status` | common.CurrentTaskStatusEnum | read-only | Current global status of the current task — one of `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `currentTasks[].type` | string | read-only | Type of the current task |
| `iam` | iam.ResourceMetadata | read-only | IAM resource metadata |
| `iam.displayName` | string | read-only | Resource display name |
| `iam.id` | string (uuid) | read-only | Unique identifier of the resource |
| `iam.state` | iam.ResourceMetadata.StateEnum | read-only | Resource state — one of `EXPIRED`, `IN_CREATION`, `OK`, `SUSPENDED` |
| `iam.tags` | object | read-only | Resource tags. Tags that were internally computed are prefixed with ovh: |
| `iam.urn` | string | read-only | Unique resource name used in policies |
| `id` | string | read-only | Unique identifier of the VMware Cloud Director backup |
| `resourceStatus` | vmwareCloudDirector.BackupResourceStatusEnum | read-only | Reflects the readiness of the VMware Cloud Director organization backup service. A new target specification request will be accepted only in `READY` status. — one of `CREATING`, `DISABLED`, `DISABLING`, `READY`, `REMOVED`, `REMOVING`, `UPDATING` |
| `targetSpec` | vmwareCloudDirector.backup.TargetSpec | read-only | Configuration you requested. While a change is still being applied it differs from currentState. |
| `targetSpec.offers` | vmwareCloudDirector.backup.TargetOffer[] | yes | List of your VMware Cloud Director backup offers |
| `targetSpec.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | yes | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `targetSpec.offers[].quotaInTB` | integer | yes | Backup repository quota in TB |
| `updatedAt` | string (date-time) | read-only | Datetime when backup is modified |

```json
{
  "createdAt": "2024-01-01T12:00:00Z",
  "currentState": {
    "azName": "ca-east-bhs-a",
    "offers": [
      {
        "name": "BRONZE",
        "protectionPrimaryRegion": "ap-south-mum",
        "protectionReplicatedRegion": "ap-south-mum",
        "quotaInTB": 0,
        "status": "CREATING",
        "usedSpaceInGB": 0
      }
    ]
  },
  "currentTasks": [
    {
      "errors": [
        {
          "message": "string"
        }
      ],
      "id": "00000000-0000-0000-0000-000000000000",
      "link": "string",
      "status": "ERROR",
      "type": "string"
    }
  ],
  "iam": {
    "displayName": "string",
    "id": "00000000-0000-0000-0000-000000000000",
    "state": "EXPIRED",
    "tags": {
      "key": "string"
    },
    "urn": "string"
  },
  "id": "string",
  "resourceStatus": "CREATING",
  "targetSpec": {
    "offers": [
      {
        "name": "BRONZE",
        "quotaInTB": 0
      }
    ]
  },
  "updatedAt": "2024-01-01T12:00:00Z"
}
```

### Example

```bash
curl -X GET \
  "https://api.eu.ovhcloud.com/v2/vmwareCloudDirector/backup/{backupId}" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN"
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

result = client.get("/v2/vmwareCloudDirector/backup/{backupId}")

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

$result = $ovh->get("/v2/vmwareCloudDirector/backup/{backupId}");

print_r($result);
?>
```

## Get a backup task

`GET /v2/vmwareCloudDirector/backup/{backupId}/task/{taskId}`

Link: https://developers.eu.ovhcloud.com/reference/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas/#get-vmwareclouddirector-backup-backupid-task-taskid

**Status:** Stable production version  
**IAM actions:** `vmwareCloudDirectorBackup:apiovh:task/get`

Returns the task: type, status, progress steps, errors and dates.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `backupId` | path | string | yes | Backup ID |
| `taskId` | path | string (uuid) | yes | Task ID |

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | common.Task | successful operation |

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `createdAt` | string (date-time) | read-only | Creation date of the task |
| `errors` | common.TaskError[] | read-only | Errors that occurred on the task |
| `errors[].message` | string | read-only | Error description |
| `finishedAt` | string (date-time) | read-only | Ending date of the task |
| `id` | string (uuid) | read-only | Unique identifier of the task |
| `link` | string | read-only | Link to the related resource |
| `message` | string | read-only | Description of the task |
| `progress` | common.TaskProgress[] | read-only | Progress steps of the asynchronous operation |
| `progress[].name` | string | read-only | Progress step name |
| `progress[].status` | common.TaskStatusEnum | read-only | Current status of the progress step — one of `DONE`, `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `startedAt` | string (date-time) | read-only | Starting date of the task |
| `status` | common.TaskStatusEnum | read-only | Current global status of the task — one of `DONE`, `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `type` | string | read-only | Type of the task |
| `updatedAt` | string (date-time) | read-only | Last update of the task |

```json
{
  "createdAt": "2024-01-01T12:00:00Z",
  "errors": [
    {
      "message": "string"
    }
  ],
  "finishedAt": "2024-01-01T12:00:00Z",
  "id": "00000000-0000-0000-0000-000000000000",
  "link": "string",
  "message": "string",
  "progress": [
    {
      "name": "string",
      "status": "DONE"
    }
  ],
  "startedAt": "2024-01-01T12:00:00Z",
  "status": "DONE",
  "type": "string",
  "updatedAt": "2024-01-01T12:00:00Z"
}
```

### Example

```bash
curl -X GET \
  "https://api.eu.ovhcloud.com/v2/vmwareCloudDirector/backup/{backupId}/task/{taskId}" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN"
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

result = client.get("/v2/vmwareCloudDirector/backup/{backupId}/task/{taskId}")

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

$result = $ovh->get("/v2/vmwareCloudDirector/backup/{backupId}/task/{taskId}");

print_r($result);
?>
```

## Update a backup service

`PUT /v2/vmwareCloudDirector/backup/{backupId}`

Link: https://developers.eu.ovhcloud.com/reference/storage-backup/backup-disaster-recovery-solutions/managed-veeam-for-public-vcf-aas/#put-vmwareclouddirector-backup-backupid

**Status:** Stable production version  
**IAM actions:** `vmwareCloudDirectorBackup:apiovh:edit`

Replaces the backup offers of the service: BRONZE, SILVER or GOLD, each with a quota in TB. An offer left out of the list is removed. Accepted only when the service is `READY`, then applied asynchronously: `currentState` catches up with `targetSpec`.

### Parameters

| Name | In | Type | Required | Description |
| --- | --- | --- | --- | --- |
| `backupId` | path | string | yes | Backup ID |

### Request body (required)

Type: `vmwareCloudDirector.backup.backupDetails.Update`

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `targetSpec` | vmwareCloudDirector.backup.TargetSpec | yes | New target specification for the VMware Cloud Director organization backup service and offers |
| `targetSpec.offers` | vmwareCloudDirector.backup.TargetOffer[] | yes | List of your VMware Cloud Director backup offers |
| `targetSpec.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | yes | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `targetSpec.offers[].quotaInTB` | integer | yes | Backup repository quota in TB |

```json
{
  "targetSpec": {
    "offers": [
      {
        "name": "BRONZE",
        "quotaInTB": 0
      }
    ]
  }
}
```

### Responses

| Status | Type | Description |
| --- | --- | --- |
| 200 | vmwareCloudDirector.backup.BackupDetails | successful operation |

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `createdAt` | string (date-time) | read-only | Datetime when backup was enabled |
| `currentState` | vmwareCloudDirector.backup.CurrentState | read-only | Configuration currently in force on the platform. It catches up with targetSpec once the requested change has been applied. |
| `currentState.azName` | vmwareCloudDirector.AZNameEnum | read-only | Availability zone of VMware Cloud Director organization backup — one of `ca-east-bhs-a`, `eu-central-waw-a`, `eu-west-eri-a`, `eu-west-lim-a`, `eu-west-rbx-a`, `eu-west-sbg-a`, `us-east-vin-a`, `us-west-hil-a` |
| `currentState.offers` | vmwareCloudDirector.backup.CurrentStateOffer[] | read-only | List of your VMware Cloud Director organization backup offers |
| `currentState.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | read-only | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `currentState.offers[].protectionPrimaryRegion` | vmwareCloudDirector.RegionNameEnum | read-only | Backup repository primary region — one of `ap-south-mum`, `ap-southeast-sgp`, `ap-southeast-syd`, `ca-east-bhs`, `ca-east-tor`, `eu-central-waw`, `eu-west-eri`, `eu-west-gra`, `eu-west-lim`, `eu-west-par`, `eu-west-rbx`, `eu-west-sbg`, … |
| `currentState.offers[].protectionReplicatedRegion` | vmwareCloudDirector.RegionNameEnum | read-only | Backup repository replicated region — one of `ap-south-mum`, `ap-southeast-sgp`, `ap-southeast-syd`, `ca-east-bhs`, `ca-east-tor`, `eu-central-waw`, `eu-west-eri`, `eu-west-gra`, `eu-west-lim`, `eu-west-par`, `eu-west-rbx`, `eu-west-sbg`, … |
| `currentState.offers[].quotaInTB` | integer | read-only | Backup repository quota in TB |
| `currentState.offers[].status` | vmwareCloudDirector.BackupResourceStatusEnum | read-only | Backup offer status — one of `CREATING`, `DISABLED`, `DISABLING`, `READY`, `REMOVED`, `REMOVING`, `UPDATING` |
| `currentState.offers[].usedSpaceInGB` | number | read-only | Backup repository used space in GB |
| `currentTasks` | common.CurrentTask[] | read-only | Asynchronous operations ongoing on the VMware Cloud Director organization backup service |
| `currentTasks[].errors` | common.TaskError[] | read-only | Errors that occurred on the task |
| `currentTasks[].errors[].message` | string | read-only | Error description |
| `currentTasks[].id` | string (uuid) | read-only | Identifier of the current task |
| `currentTasks[].link` | string | read-only | Link to the task details |
| `currentTasks[].status` | common.CurrentTaskStatusEnum | read-only | Current global status of the current task — one of `ERROR`, `PENDING`, `RUNNING`, `SCHEDULED`, `WAITING_USER_INPUT` |
| `currentTasks[].type` | string | read-only | Type of the current task |
| `id` | string | read-only | Unique identifier of the VMware Cloud Director backup |
| `resourceStatus` | vmwareCloudDirector.BackupResourceStatusEnum | read-only | Reflects the readiness of the VMware Cloud Director organization backup service. A new target specification request will be accepted only in `READY` status. — one of `CREATING`, `DISABLED`, `DISABLING`, `READY`, `REMOVED`, `REMOVING`, `UPDATING` |
| `targetSpec` | vmwareCloudDirector.backup.TargetSpec | read-only | Configuration you requested. While a change is still being applied it differs from currentState. |
| `targetSpec.offers` | vmwareCloudDirector.backup.TargetOffer[] | yes | List of your VMware Cloud Director backup offers |
| `targetSpec.offers[].name` | vmwareCloudDirector.BackupOfferNameEnum | yes | Backup service offer type (BRONZE\|SILVER\|GOLD) — one of `BRONZE`, `GOLD`, `SILVER` |
| `targetSpec.offers[].quotaInTB` | integer | yes | Backup repository quota in TB |
| `updatedAt` | string (date-time) | read-only | Datetime when backup is modified |

```json
{
  "createdAt": "2024-01-01T12:00:00Z",
  "currentState": {
    "azName": "ca-east-bhs-a",
    "offers": [
      {
        "name": "BRONZE",
        "protectionPrimaryRegion": "ap-south-mum",
        "protectionReplicatedRegion": "ap-south-mum",
        "quotaInTB": 0,
        "status": "CREATING",
        "usedSpaceInGB": 0
      }
    ]
  },
  "currentTasks": [
    {
      "errors": [
        {
          "message": "string"
        }
      ],
      "id": "00000000-0000-0000-0000-000000000000",
      "link": "string",
      "status": "ERROR",
      "type": "string"
    }
  ],
  "id": "string",
  "resourceStatus": "CREATING",
  "targetSpec": {
    "offers": [
      {
        "name": "BRONZE",
        "quotaInTB": 0
      }
    ]
  },
  "updatedAt": "2024-01-01T12:00:00Z"
}
```

### Example

```bash
curl -X PUT \
  "https://api.eu.ovhcloud.com/v2/vmwareCloudDirector/backup/{backupId}" \
  -H "accept: application/json" \
  -H "authorization: Bearer $OVH_TOKEN" \
  -H "content-type: application/json" \
  -d '{ }'
```

```python
'''
First, install the latest release of Python wrapper: $ pip install ovh
'''
import json
import ovh

# Instantiate an OVH Client.
# You can generate new credentials with full access to your account on
# the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
client = ovh.Client(
	endpoint='ovh-eu',               # Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
	application_key='xxxxxxxxxx',    # Application Key
	application_secret='xxxxxxxxxx', # Application Secret
	consumer_key='xxxxxxxxxx',       # Consumer Key
)

# Request body type: vmwareCloudDirector.backup.backupDetails.Update
result = client.put("/v2/vmwareCloudDirector/backup/{backupId}",
	targetSpec = None, # New target specification for the VMware Cloud Director organization backup service and offers (type: vmwareCloudDirector.backup.TargetSpec)
)

# Pretty print
print(json.dumps(result, indent=4))
```

```php
<?php
/**
 * First, download the latest release of PHP wrapper on github
 * And include this script into the folder with extracted files
 */
require __DIR__ . '/vendor/autoload.php';
use \Ovh\Api;

/**
 * Instantiate an OVH Client.
 * You can generate new credentials with full access to your account on
 * the token creation page (https://api.ovh.com/createToken/index.cgi?GET=/*&PUT=/*&POST=/*&DELETE=/*)
 */
$ovh = new Api('xxxxxxxxxx',  // Application Key
               'xxxxxxxxxx',  // Application Secret
               'ovh-eu',      // Endpoint of API OVH (List of available endpoints: https://github.com/ovh/python-ovh#2-configure-your-application)
               'xxxxxxxxxx'); // Consumer Key

// Request body type: vmwareCloudDirector.backup.backupDetails.Update
$result = $ovh->put("/v2/vmwareCloudDirector/backup/{backupId}", array(
	targetSpec => null, // New target specification for the VMware Cloud Director organization backup service and offers (type: vmwareCloudDirector.backup.TargetSpec)
));

print_r($result);
?>
```
